// MyFirstProjectDoc.cpp : implementation of the CMyFirstProjectDoc class
//

/*

	author:			Babak Taati ( http://qlink.queensu.ca/~3bt1/ )
	Download link:	http://qlink.queensu.ca/~3bt1/Miscellaneous/Downloads.htm	

	Description:	This is a simple project that allows opening / saving multiple types of documents
  
	References: 	1. MFC Document/View documentation and enhancements, by Roger Allen on CodeProject.com
					2. How to support two file extensions per MFC document type, Micorosft support document Article ID 141921
					3. DocMgrEx.exe Assoc Multiple File Extension w/2 Doc Tyle, Micorosft support document Article ID 198538
					4. Selecting multiple files in File Open dialog, by Kaus Gutter on CodeGuru.com
					5. Opening multiple documents of several types at once, by Ernesto Perales Soto on CodeProject.com

	Date:			Nov 2004

*/

#include "stdafx.h"
#include "MyFirstProject.h"

#include "MyFirstProjectDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyFirstProjectDoc

IMPLEMENT_DYNCREATE(CMyFirstProjectDoc, CDocument)

BEGIN_MESSAGE_MAP(CMyFirstProjectDoc, CDocument)
	//{{AFX_MSG_MAP(CMyFirstProjectDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyFirstProjectDoc construction/destruction

CMyFirstProjectDoc::CMyFirstProjectDoc()
{
	// TODO: add one-time construction code here

}

CMyFirstProjectDoc::~CMyFirstProjectDoc()
{
}

BOOL CMyFirstProjectDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CMyFirstProjectDoc serialization

void CMyFirstProjectDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMyFirstProjectDoc diagnostics

#ifdef _DEBUG
void CMyFirstProjectDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMyFirstProjectDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMyFirstProjectDoc commands




//Babak: overriding DoSave

BOOL CMyFirstProjectDoc::DoSave(LPCTSTR lpszPathName, BOOL bReplace)
	// Save the document data to a file
	// lpszPathName = path name where to save document file
	// if lpszPathName is NULL then the user will be prompted (SaveAs)
	// note: lpszPathName can be different than 'm_strPathName'
	// if 'bReplace' is TRUE will change file name if successful (SaveAs)
	// if 'bReplace' is FALSE will not change path name (SaveCopyAs)
{
	CString newName = lpszPathName;
	if (newName.IsEmpty())
	{
		CDocTemplate* pTemplate = GetDocTemplate();
		ASSERT(pTemplate != NULL);

		newName = m_strPathName;
		if (bReplace && newName.IsEmpty())
		{
			newName = m_strTitle;
			// check for dubious filename
			int iBad = newName.FindOneOf(_T(" #%;/\\"));
			if (iBad != -1)
				newName.ReleaseBuffer(iBad);


			//Babak: have to change the following ...

			/*
			// append the default suffix if there is one
			CString strExt;
			if (pTemplate->GetDocString(strExt, CDocTemplate::filterExt) &&
	            !strExt.IsEmpty())
			{
				ASSERT(strExt[0] == '.');
				newName += strExt;
			}
			*/

			// ... Babak: to this ...
			
			/* 
	        // append the default suffix if there is one
			CString strExt;
			if (pTemplate->GetDocString(strExt, CDocTemplate::filterExt) &&
	            !strExt.IsEmpty())
			{
				ASSERT(strExt[0] == '.');
		
				int nSemi;                       //added
				if(nSemi = strExt.Find(';'));    //added
				strExt = strExt.Left(nSemi);     //added
		
				newName += strExt;
	        }
			*/
			// ... Babak: end

		}



		//Babak: have to change the following ...

		/*
		if (!AfxGetApp()->DoPromptFileName(newName,
		  bReplace ? AFX_IDS_SAVEFILE : AFX_IDS_SAVEFILECOPY,
		  OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, FALSE, pTemplate))
			return FALSE;       // don't even attempt to save
		*/

		// ... Babak: to this ...
		
		if (!AfxGetApp()->DoPromptFileName(newName,
		  bReplace ? AFX_IDS_SAVEFILE : AFX_IDS_SAVEFILECOPY,
		  OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, FALSE, NULL))
			return FALSE;       // don't even attempt to save
		
		// ... Babak: end
			



	}

	CWaitCursor wait;

	if (!OnSaveDocument(newName))
	{
		if (lpszPathName == NULL)
		{
			// be sure to delete the file
			TRY
			{
				CFile::Remove(newName);
			}
			CATCH_ALL(e)
			{
				TRACE0("Warning: failed to delete file after failed SaveAs.\n");
				e->Delete();     //modified
			}
			END_CATCH_ALL
		}
		return FALSE;
	}

	// reset the title and change the document name
	if (bReplace)
		SetPathName(newName);

	return TRUE;        // success
}